"use strict";
/* tslint:disable:no-console */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// It's a copy of upstream cli.ts except this import
const lsp_connection_1 = require("./lsp-connection");
const utils_1 = require("@elastic/typescript-language-server/lib/utils");
const commander_1 = require("commander");
const lsp = __importStar(require("vscode-languageserver"));
const program = new commander_1.Command('typescript-language-server')
    // tslint:disable-next-line:no-var-requires
    .version(require('../package.json').version)
    .option('--stdio', 'use stdio')
    .option('--node-ipc', 'use node-ipc')
    .option('--log-level <logLevel>', 'A number indicating the log level (4 = log, 3 = info, 2 = warn, 1 = error). Defaults to `2`.')
    .option('--socket <port>', 'use socket. example: --socket=5000')
    .option('--tsserver-log-file <tsserverLogFile>', 'Specify a tsserver log file. example: --tsserver-log-file ts-logs.txt')
    .option('--tsserver-log-verbosity <tsserverLogVerbosity>', 'Specify a tsserver log verbosity (terse, normal, verbose). Defaults to `normal`.' +
    ' example: --tsserver-log-verbosity verbose')
    .option('--tsserver-path <path>', `Specify path to tsserver. example: --tsserver-path=${utils_1.getTsserverExecutable()}`)
    .parse(process.argv);
if (!(program.stdio || program.socket || program.nodeIpc)) {
    console.error('Connection type required (stdio, node-ipc, socket). Refer to --help for more details.');
    process.exit(1);
}
if (program.tsserverLogFile && !program.tsserverLogVerbosity) {
    program.tsserverLogVerbosity = 'normal';
}
let logLevel = lsp.MessageType.Warning;
if (program.logLevel) {
    logLevel = parseInt(program.logLevel, 10);
    if (logLevel && (logLevel < 1 || logLevel > 4)) {
        console.error('Invalid `--log-level ' + logLevel + '`. Falling back to `info` level.');
        logLevel = lsp.MessageType.Warning;
    }
}
function delay(ms) {
    return new Promise((resolve) => setTimeout(resolve, ms));
}
// while (true) {
function listen() {
    const otherOptions = new Map();
    otherOptions.set('--useSingleInferredProject', 'true');
    otherOptions.set('--suppressDiagnosticEvents', 'true');
    otherOptions.set('--noGetErrOnBackgroundUpdate', 'true');
    lsp_connection_1.createLspConnection({
        tsserverPath: require.resolve('typescript/bin/tsserver'),
        tsserverLogFile: program.tsserverLogFile,
        tsserverLogVerbosity: program.tsserverLogVerbosity,
        showMessageLevel: logLevel,
        otherOptions,
    }).listen();
    console.log('Reconnecting');
    // setTimeout(listen, 1000);
}
listen();
//# sourceMappingURL=cli.js.map