"use strict";
/*tslint:disable:member-access*/
/*tslint:disable:max-classes-per-file*/
Object.defineProperty(exports, "__esModule", { value: true });
// import * as glob from 'fast-glob'
// import got from 'got'
// import { FORMAT_HTTP_HEADERS, Span, Tracer } from 'opentracing'
class ResourceNotFoundError extends Error {
    constructor(resource) {
        super(`Resource not found: ${resource}`);
        this.resource = resource;
        this.name = 'ResourceNotFoundError';
    }
}
exports.ResourceNotFoundError = ResourceNotFoundError;
/**
 * Walks through the parent directories of a given URI.
 * Starts with the directory of the start URI (or the start URI itself if it is a directory).
 * Yielded directories will always have a trailing slash.
 */
function* walkUp(start) {
    let current = new URL('.', start);
    while (true) {
        yield current;
        const parent = new URL('..', current);
        if (parent.href === current.href) {
            // Reached root
            return;
        }
        current = parent;
    }
}
exports.walkUp = walkUp;
//# sourceMappingURL=resources.js.map